
// Let's scope all of our stuff to an object.
window.adventist = { corporate: {} };

// Self-calling function that passes in an anonymous jQuery 1.9.1 for use with
// the $ variable.
(function($) {

  // Let's alias that longer module name here so we can more easily attach
  // functionality and use things stored there.
  var AC = window.adventist.corporate;



  // sets all .third areas to be the same height
  AC.thirds = function() {
    var maxHeight = -1;

    $('.thirds').each(function() {
      maxHeight = maxHeight > $(this).height() ? maxHeight : $(this).height();
    });

    $('.third').each(function() {
      $(this).height(maxHeight-80);
    });
  }



  $(function() {

    // Initialize the same-height-ness of .thirds
    AC.thirds();



    // Do some special things when we have body.full-width-hero
    if ($('body.full-width-hero').length) {

      // Ensure that really skinny, responsive header slideshows conform to a
      // min-height.
      $('#hero_unit .ss-slide-scroller').each(function() {
        var $scroller = $(this);

        if ($scroller.find('img').length) {
          var klass = 'size-by-height';

          var checkScrollerSize = function() {
            var minHeight = parseFloat($scroller.css('minHeight'));
            var height    = parseFloat($scroller.get(0).style.height);
            $scroller[height < minHeight ? 'addClass' : 'removeClass'](klass);
          }

          $(window).resize(checkScrollerSize());
          checkScrollerSize();
        }
      });


      // Create special "Find out more" buttons for each slide that has a link
      var moreText = $('#find-out-more-text').data('find-out-more');
      $('.ss-text-scroller .ss-link-wrapper').each(function() {
        var $link     = $(this);
        var $textBox  = $link.children('.ss-text-box');
        $textBox.insertBefore($link)
                .append(
                  $('<span class="ac-link-wrapper"></span>').append(
                    $link.text(moreText)
                  )
                );
      });


      // Initialize BackgroundCheck
      if (typeof BackgroundCheck !== "undefined" && BackgroundCheck !== null) {
        var elementsQuery = 'header h1 a, header h2, #site-nav, #site-search a, #hero_unit .ss-slide-description, #hero_unit .ss-controls';
        BackgroundCheck.init({
          targets:  elementsQuery,
          images:   '#hero_unit .ss-slide-scroller .ss-section'
        });

        // Gotta tap into the jQuery 1.10.2 elements by accessing them from the
        // global window.Slideshows.all collection. Bleh. Too many jQuery
        // versions going on in here!
        var SS = window.Slideshows || (window.Slideshows = {});
        $.each(SS.all || [], function() {
          if (this.$wrapper.parents('#hero_unit').length) {
            this.$wrapper.on('advanced.slideshow', function(e, payload) {
              // Recheck the header items against the background after each
              // slide change.
              BackgroundCheck.refresh();
            });
          }
        });
      }

    }



    // Main navigation drop-down menus
    $('.nav').hover(function() {
      if ($(this).hasClass('active')) {
        $(this).removeClass('active');
        $(this).addClass('was-active');
      }
      $(this).addClass('hover');
    }, function() {
      $(this).removeClass('hover');
      if ($(this).hasClass('was-active')) {
        $(this).removeClass('was-active');
        $(this).addClass('active');
      }
    });



    // Toggle the mobile menu from its hamburger menu button
    $('#mobile-menu').on('click', function(e) {
      e.preventDefault();
      $('nav').toggleClass('show-me');
    });



    // Show/hide sub-menus when the navigation is in a sidebar
    $('ul#side-nav li').on('click', function(e) {
      e.preventDefault();
      $('.side-nav-sub').hide();
      $(this).children('ul').toggle();
    });

  });

// .noConflict(true) simply returns the jQuery object without assigning it to
// any global variable
})(jQuery.noConflict(true));
